<template>
	<text
	    class="uv-link"
	    @tap.stop="openLink"
	    :style="[linkStyle, $uv.addStyle(customStyle)]"
	>{{text}}</text>
</template>

<script>
	import mpMixin from '@/uni_modules/uv-ui-tools/libs/mixin/mpMixin.js'
	import mixin from '@/uni_modules/uv-ui-tools/libs/mixin/mixin.js'
	import props from './props.js';
	/**
	 * link 超鏈接
	 * @description 該組件為超鏈接組件，在不同平臺有不同表現形式：在APP平臺會通過plus環境打開內置瀏覽器，在小程序中把鏈接復制到粘貼板，同時提示信息，在H5中通過window.open打開鏈接。
	 * @tutorial https://www.uvui.cn/components/link.html
	 * @property {String}			color		文字顏色 （默認 color['uv-primary'] ）
	 * @property {String ｜ Number}	fontSize	字體大小，單位px （默認 15 ）
	 * @property {Boolean}			underLine	是否顯示下劃線 （默認 false ）
	 * @property {String}			href		跳轉的鏈接，要帶上http(s)
	 * @property {String}			mpTips		各個小程序平臺把鏈接復制到粘貼板後的提示語（默認“鏈接已復制，請在瀏覽器打開”）
	 * @property {String}			lineColor	下劃線顏色，默認同color參數顏色 
	 * @property {String}			text		超鏈接的問題，不使用slot形式傳入，是因為nvue下無法修改顏色 
	 * @property {Object}			customStyle	定義需要用到的外部樣式
	 * 
	 * @example <uv-link href="http://www.uvui.cn">蜀道難，難於上青天</uv-link>
	 */
	export default {
		name: "uv-link",
		emits:['click'],
		mixins: [mpMixin, mixin, props],
		computed: {
			linkStyle() {
				const style = {
					color: this.color,
					fontSize: this.$uv.addUnit(this.fontSize),
					// line-height設置為比字體大小多2px
					lineHeight: this.$uv.addUnit(this.$uv.getPx(this.fontSize) + 2),
					textDecoration: this.underLine ? 'underline' : 'none'
				}
				return style
			}
		},
		methods: {
			openLink() {
				// #ifdef APP-PLUS
				plus.runtime.openURL(this.href)
				// #endif
				// #ifdef H5
				window.open(this.href)
				// #endif
				// #ifdef MP
				uni.setClipboardData({
					data: this.href,
					success: () => {
						uni.hideToast();
						this.$nextTick(() => {
							this.$uv.toast(this.mpTips);
						})
					}
				});
				// #endif
				this.$emit('click')
			}
		}
	}
</script>

<style lang="scss" scoped>
	@import '@/uni_modules/uv-ui-tools/libs/css/components.scss';
	@import '@/uni_modules/uv-ui-tools/libs/css/color.scss';
	$uv-link-line-height:1 !default;

	.uv-link {
		/* #ifndef APP-NVUE */
		line-height: $uv-link-line-height;
		/* #endif */
		@include flex;
		flex-wrap: wrap;
		flex: 1;
		color: $uv-primary;
	}
</style>
